<template>
  <div>
    <div class="titleBox">
      <PageTitle title="重点群体管理">
        <el-popover placement="bottom" :visible="visible" :width="400" trigger="click">
          <template #reference>
            <el-button type="primary" @click="(visible = !visible), (visiblefp = false)" size="small">布控申请
            </el-button>
          </template>
          <div class="flex just-center">
            <el-button size="small" type="primary" v-for="it in D_GS_BK_SQLX" :key="it.dm" @click="handleApplication(it)">{{it.zdmc }}</el-button>
          </div>
        </el-popover>
        <el-popover placement="bottom" :visible="visiblefp" :width="400" trigger="click">
          <template #reference>
            <el-button size="small" type="primary" @click="(visiblefp = !visiblefp), (visible = false)">指定分配</el-button>
          </template>
          <div>
            <el-input readonly v-model="obj.fpmc" @click="chooseUserVisible = true" placeholder="请选择民警"></el-input>
            <div class="flex just-center mt10">
              <el-button @click="(visiblefp = false), (obj = {})" size="small">取消</el-button>
              <el-button type="primary" @click="handlefp" size="small">分配</el-button>
            </div>
          </div>
        </el-popover>

        <el-button size="small" type="primary" @click="handleZxs">转线索</el-button>
        <el-button size="small" type="primary" @click="handleMove">移交管控</el-button>
        <el-button type="primary" size="small" @click="addEdit('add', null)">
          <el-icon style="vertical-align: middle">
            <CirclePlus />
          </el-icon>
          <span style="vertical-align: middle">新增</span>
        </el-button>
      </PageTitle>
    </div>
    <!-- 搜索 -->
    <div ref="searchBox">
      <Search :searchArr="searchConfiger" @submit="onSearch" />
    </div>
    <!-- 表格 -->
    <div class="tabBox">
      <MyTable
        :tableData="pageData.tableData"
        :tableColumn="pageData.tableColumn"
        :tableHeight="pageData.tableHeight"
        :key="pageData.keyCount"
        :tableConfiger="pageData.tableConfiger"
        :controlsWidth="pageData.controlsWidth"
        @chooseData="chooseData"
      >
      <template #qtLb="{ row }">
        <DictTag :tag="false" :value="row.qtLb" :options="D_GS_ZDQT_LB" />
        </template>
        <template #qtFxdj="{ row }">
        <DictTag :tag="false" :value="row.qtFxdj" :options="D_GS_ZDQT_FXDJ" />
        </template>
         <template #bqList="{ row }">
          <ul >
            <li class="one_text_detail marks mb4" :key="index" v-for="(item, index) in row.bqList">{{ item.bqMc }}({{ item.bqFz || 0  }} 分) </li>
          </ul>
        </template>
        <template #zdryList="{ row }">
          <span style="color: #0072ff">{{ row.zdryList ? row.zdryList.length : 0 }}</span>
        </template>
        <template #qtZt="{ row }">
          <DictTag :tag="false" :value="row.qtZt" :options="D_GS_ZDQT_ZT" />
        </template>
        <!-- 操作 -->
        <template #controls="{ row }">
          <el-link size="small" type="primary" v-if=" row.qtZt == '01'" @click="handleSend(row.id)">办结</el-link>
          <el-link size="small" type="success" v-if=" row.qtZt == '01'" @click="addEdit('edit', row)">编辑</el-link>
          <el-link size="small" type="success" @click="addEdit('detail', row)">详情</el-link>
          <el-link size="small" type="danger" @click="deleteRow(row.id)">删除</el-link>
        </template>
      </MyTable>
      <Pages @changeNo="changeNo" @changeSize="changeSize" :tableHeight="pageData.tableHeight" :pageConfiger="{
        ...pageData.pageConfiger,
        total: pageData.total
      }"></Pages>
    </div>
    <!-- 编辑 - 新增-->
    <EditForm v-if="show" @updateDate="getList" ref="editFormDiloag" :dic="{D_BZ_XB,D_GS_ZDQT_LB,D_GS_ZDQT_FXDJ,D_GS_ZDR_CZZT}" />
    <!-- 选择用户 -->
    <ChooseUser v-model="chooseUserVisible" @choosedUsers="handleUserSelected" :roleIds="roleIds" />    <!-- 转线索 -->
    <ZxsForm v-if="showzxs" ref="zxsDilof" @change="getList" :dic="{ D_BZ_SF, D_BZ_XB, D_GS_XS_LY, D_BZ_SSZT, D_GS_XS_LX, D_GS_XS_QTLX }"></ZxsForm>
  </div>
</template>

<script setup>
import ZxsForm from "./components/zxsForm.vue";
import ChooseUser from "@/components/ChooseList/ChooseUser/index.vue";
import PageTitle from "@/components/aboutTable/PageTitle.vue";
import MyTable from "@/components/aboutTable/MyTable.vue";
import Pages from "@/components/aboutTable/Pages.vue";
import Search from "@/components/aboutTable/Search.vue";
import EditForm from "./components/addForm.vue";
import { qcckGet, qcckPost, qcckDelete } from "@/api/qcckApi.js";
import { ElMessage } from "element-plus";
import { reactive, ref, onMounted, getCurrentInstance, nextTick } from "vue";
const { proxy } = getCurrentInstance();
const { D_GS_ZDR_CZZT,D_GS_BK_SQLX, D_GS_ZDQT_FXDJ, D_GS_ZDR_RYJB, D_GS_ZDQT_LB, D_GS_ZDR_BK_ZT, D_GS_BQ_LX, D_GS_ZDQT_ZT, D_BZ_SF, D_BZ_XB, D_GS_XS_LY, D_BZ_SSZT, D_GS_XS_LX, D_GS_XS_QTLX } = proxy.$dict("D_GS_ZDR_CZZT","D_GS_BK_SQLX", "D_GS_ZDQT_FXDJ", "D_GS_ZDR_RYJB", "D_GS_ZDQT_LB", "D_GS_ZDR_BK_ZT", "D_GS_BQ_LX", "D_GS_ZDQT_ZT", "D_BZ_SF", "D_BZ_XB", "D_GS_XS_LY", "D_BZ_SSZT", "D_GS_XS_LX", "D_GS_XS_QTLX"); //获取字典数据
const showzxs = ref(false);
const queryFrom = ref({});
const ids = ref([]);
const choosList = ref([]);
const show = ref(false);
const chooseUserVisible = ref(false); //审批流程
const roleIds = ref([]); //角色id
const editFormDiloag = ref();
const searchBox = ref(); //搜索框
const visible = ref(false);
const visiblefp = ref(false);
const zxsDilof = ref();
const obj = ref({});
const searchConfiger = ref([
  {
    label: "群体名称",
    prop: "qtMc",
    placeholder: "请输入群体名称",
    showType: "input"
  },
  {
    label: "群体风险等级",
    prop: "qtFxdj",
    placeholder: "请选择群体风险等级",
    showType: "select",
    options: D_GS_ZDQT_FXDJ
  },
  {
    label: "重点人人员级别",
    prop: "zdrRyjb",
    placeholder: "请选择重点人人员级别",
    showType: "select",
    options: D_GS_ZDR_RYJB
  },
  {
    label: "群体类别",
    prop: "qtLb",
    placeholder: "请选择群体类别",
    showType: "select",
    options: D_GS_ZDQT_LB
  },
  {
    label: "布控状态",
    prop: "zdrBkZt",
    placeholder: "请输入布控装态",
    showType: "select",
    options: D_GS_ZDR_BK_ZT
  },
  {
    label: "布控类型",
    prop: "bkzt",
    placeholder: "请输入布控类型",
    showType: "select",
    options: D_GS_BQ_LX
  }
]);

const pageData = reactive({
  tableData: [],
  keyCount: 0,
  tableConfiger: {
    rowHieght: 61,
    showSelectType: "checkBox",
    loading: false
  },
  total: 0,
  pageConfiger: {
    pageSize: 20,
    pageCurrent: 1
  },
  controlsWidth: 150,
  tableColumn: [
    { label: "群体名称", prop: "qtMc" },
    { label: "群体类别", prop: "qtLb" , showSolt: true},
    { label: "风险等级", prop: "qtFxdj" , showSolt: true},
    { label: "背景资料", prop: "qtBjzl" },
    { label: "背景信息", prop: "bgxx", showSolt: true },
    { label: "管辖单位", prop: "gxSsdwmc" },
    { label: "列控原因", prop: "zdrLkyy" },
    { label: "开始时间", prop: "zdrRkkssj" },
    { label: "截至时间", prop: "zdrRkjssj" },
    { label: "稳控人数", prop: "zdryList", showSolt: true },
    { label: "状态", prop: "qtZt", showSolt: true },
    { label: "标签", prop: "bqList", showSolt: true ,showOverflowTooltip:true},
    { label: "创建单位", prop: "xtCjbmmc" },
    { label: "创建时间", prop: "xtCjsj" },
  ]
});

onMounted(() => {
  tabHeightFn();
  getList();
});

//送审
const handleSend = (id) => {
  proxy.$confirm("确定要办结？", "警告", { type: "warning" }).then(() => {
    qcckPost({}, "/mosty-gsxt//tbGsxtZdqt/qtbj/"+id).then(() => {
      proxy.$message({ type: "success", message: "办结成功" });
      getList();
    });
  })
};


// 搜索
const onSearch = (val) => {
  queryFrom.value = { ...val };
  pageData.pageConfiger.pageCurrent = 1;
  getList();
};

const changeNo = (val) => {
  pageData.pageConfiger.pageCurrent = val;
  getList();
};
const changeSize = (val) => {
  pageData.pageConfiger.pageSize = val;
  getList();
};

// 获取列表
const getList = () => {
  pageData.tableConfiger.loading = true;
  let data = { ...pageData.pageConfiger, ...queryFrom.value };
  qcckGet(data, "/mosty-gsxt/tbGsxtZdqt/selectPage").then((res) => {
    pageData.tableData = res.records || [];
    pageData.total = res.total;
    pageData.tableConfiger.loading = false;
  }).catch(() => {
    pageData.tableConfiger.loading = false;
  });
};

// 详情
const addEdit = (type, row) => {
  show.value = true;
  visible.value = false;
  nextTick(() => {
    editFormDiloag.value.init(type, row);
  });
};

const chooseData = (data) => {
  ids.value = Array.isArray(data) ? data.map((item) => item.id) : [];
  choosList.value = Array.isArray(data) ? data : [];
};
// 选择申请数据数据
const handleApplication = () => {
  if (ids.value.length === 0)return ElMessage.error("请先选择需要布控的重点群体");
  qcckPost({ ids: ids.value }, "/mosty-gsxt/tbGsxtZdqt/addBksq").then(() => {
    ElMessage.success("申请成功");
    visible.value = false;
    getList();
  }).catch(() => {
    ElMessage.error("布控申请失败");
  });
};

const handleUserSelected = (val) => {
  obj.value.fpmc = val[0].userName;
  obj.value.fpid = val[0].id;
};

const handlefp = () => {
  if (ids.value.length === 0) return ElMessage.error("请先选择需要分配的重点群体");
  qcckPost({ ids: ids.value, uid: obj.value.fpid },"/mosty-gsxt/tbGsxtZdqt/addGkmj").then(() => {
    ElMessage.success("分配成功");
    visible.value = false;
    visiblefp.value = false;
    getList();
  }).catch(() => {
    ElMessage.error("分配失败");
  });
};
// 移交管控
const handleMove = () => {
  if (ids.value.length === 0) return ElMessage.error("请先选择需要移交管控的重点群体");
  proxy.$confirm("是否确定移交？", "警告", { type: "warning" }).then(() => {
    qcckPost({ ids: ids.value }, "/mosty-gsxt/tbGsxtZdqt/addSfyj").then(() => {
      ElMessage.success("移交管控成功");
      getList();
    }).catch(() => {
      ElMessage.error("移交管控失败");
    });
  }).catch(() => { });
};

const handleZxs = () => {
  if (ids.value.length === 0) return ElMessage.error("请先选择需要转线索的重点群体");
  showzxs.value = true;
  nextTick(() => {
    zxsDilof.value.init(choosList.value);
  });
};

// 删除数据
const deleteRow = (id) =>{
  proxy.$confirm("确定要删除", "警告", { type: "warning" }).then(() => {
    qcckDelete({}, "/mosty-gsxt/tbGsxtZdqt/" + id).then(() => {
      proxy.$message({ type: "success", message: "删除成功" });
      getList();
    });
  })
}

// 表格高度计算
const tabHeightFn = () => {
  pageData.tableHeight = window.innerHeight - searchBox.value.offsetHeight - 250;
  window.onresize = function () {
    tabHeightFn();
  };
};
defineExpose({});
</script>

<style lang="scss" scoped>
.marks{
  padding: 0 4px;
  white-space: nowrap;
  background: #73acf1;
  border-radius: 4px;
  color: #fff;
}
</style>

<style>
.el-loading-mask {
  background: rgba(0, 0, 0, 0.5) !important;
}

</style>
